var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import LivePreview from './components/LivePreview';
import Playground from './components/Playground';
import addons from '@storybook/addons';
export { LivePreview, Playground };
/**
 * this is HoC that wraps the story with the LivePreview component
 * returned component will have liveEdit in parameters
 */
export function generateLivePreviewStory(props) {
    const Story = () => {
        return React.createElement(LivePreview, Object.assign({}, props, { channel: addons.getChannel() }));
    };
    Story.parameters = {
        liveEdit: {
            showEditor: true,
        },
    };
    return Story;
}
const DefaultLiveEdit = {
    showEditor: false,
    withLiveDecorator: false,
    scope: {},
};
/**
 * this storybook decorator is used to replace the story with a live preview.
 * this decorator will read the story's source code, so we can avoid writing live preview's code in plain text.
 * but you still need to provide scope or custom {@see LivePreviewProps} via liveEdit in the story's parameters.
 */
export function liveDecorator(Story, storyData) {
    var _a, _b, _c;
    const liveEdit = ((_a = storyData.parameters) === null || _a === void 0 ? void 0 : _a.liveEdit) || DefaultLiveEdit;
    const { showEditor, withLiveDecorator } = liveEdit, livePreviewProps = __rest(liveEdit, ["showEditor", "withLiveDecorator"]);
    if (!withLiveDecorator)
        return React.createElement(Story, null);
    return (React.createElement(LivePreview, Object.assign({}, livePreviewProps, { channel: addons.getChannel(), code: ((_c = (_b = storyData.parameters) === null || _b === void 0 ? void 0 : _b.storySource) === null || _c === void 0 ? void 0 : _c.source) || '' })));
}
